package core;

import java.util.*;
import core.*;
import util.*;

public abstract class Cell
{
	private Integer ID;
	private String state;
	private SystemModel sys;
	private CellProgram cp;

	public Cell(Integer p_ID, SystemModel p_sys, CellProgram p_cp)
	{
		ID = new Integer(p_ID.intValue());
		sys = p_sys;
		cp = p_cp;
	}

	public Integer getID() { return ID; }

	public String getState() { return new String(state); }

	public void setState(String p_state) { state = new String(p_state); }

	public SystemModel getSystem() { return sys; }

	public CellProgram getCellProgram() { return cp; }

	public void runCellProgramForOneStep() { cp.runCellProgramForOneStep(this);	}

	public abstract void init(Vector args);
	public abstract Vector provideService(Vector args);
	public abstract Color getColor();
}
