package gui;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import gui.*;
import gui.dialogs.*;

class MainToolBar extends JToolBar
{
	SimWinMgr simWinMgr;

	JButton bFileNew;
	JButton bFileOpen;
	JButton bFileClose;
	JButton bFileExit;
	JButton bSimulationStep;
	JButton bSimulationGoTo;
	JButton bHelpAbout;

	public MainToolBar(SimWinMgr swMgr)
	{
		simWinMgr = swMgr;
		ToolBarItemListener tbil = new ToolBarItemListener();

		bFileNew = new JButton("New");
		bFileOpen = new JButton("Open");
		bFileClose = new JButton("Close");
		bFileExit = new JButton("Exit");
		bSimulationStep = new JButton("Step");
		bSimulationGoTo = new JButton("Go To");
		bHelpAbout = new JButton("About");

		bFileNew.addActionListener(tbil);
		bFileOpen.addActionListener(tbil);
		bFileClose.addActionListener(tbil);
		bFileExit.addActionListener(tbil);
		bSimulationStep.addActionListener(tbil);
		bSimulationGoTo.addActionListener(tbil);
		bHelpAbout.addActionListener(tbil);

		add(bFileNew);
		add(bFileOpen);
		add(bFileClose);
		add(bFileExit);
		addSeparator();
		add(bSimulationStep);
		add(bSimulationGoTo);
		addSeparator();
		add(bHelpAbout);
	}

	class ToolBarItemListener implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			JButton button = (JButton)e.getSource();
			if(button == bFileNew)
			{
				FileNewDialog fileNewDialog = new FileNewDialog(simWinMgr);
				Vector retVec = fileNewDialog.getFileNames(simWinMgr.getSavedOptionsFileNew());
				if(retVec != null)
				{
					simWinMgr.createSimulationWindow(retVec);
					simWinMgr.setSavedOptionsFileNew(retVec);
				}
			}
			else if(button == bFileClose)
			{
				simWinMgr.closeCurrentSimulationWindow();
			}
			else if(button == bFileExit)
			{
				if(simWinMgr.exit())
					System.exit(0);
			}
			else if(button == bSimulationStep)
			{
				simWinMgr.nextStep();
			}
		}
	}
}
